/*
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.ide.contentassist.antlr;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.Map;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;
import org.xtext.example.methodname.ide.contentassist.antlr.internal.InternalMethodNameParser;
import org.xtext.example.methodname.services.MethodNameGrammarAccess;

public class MethodNameParser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(MethodNameGrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, MethodNameGrammarAccess grammarAccess) {
			builder.put(grammarAccess.getRuleAccess().getAlternatives(), "rule__Rule__Alternatives");
			builder.put(grammarAccess.getRuleAccess().getCompOpAlternatives_0_11_0(), "rule__Rule__CompOpAlternatives_0_11_0");
			builder.put(grammarAccess.getAndAccess().getConcatKindAlternatives_1_1_0(), "rule__And__ConcatKindAlternatives_1_1_0");
			builder.put(grammarAccess.getPrimaryAccess().getAlternatives(), "rule__Primary__Alternatives");
			builder.put(grammarAccess.getAtomicAccess().getAlternatives(), "rule__Atomic__Alternatives");
			builder.put(grammarAccess.getKindAccess().getAlternatives(), "rule__Kind__Alternatives");
			builder.put(grammarAccess.getSentimentAccess().getAlternatives(), "rule__Sentiment__Alternatives");
			builder.put(grammarAccess.getPOSAccess().getAlternatives(), "rule__POS__Alternatives");
			builder.put(grammarAccess.getCardinalityModifierAccess().getAlternatives(), "rule__CardinalityModifier__Alternatives");
			builder.put(grammarAccess.getFrequencyAccess().getAlternatives(), "rule__Frequency__Alternatives");
			builder.put(grammarAccess.getModelAccess().getGroup(), "rule__Model__Group__0");
			builder.put(grammarAccess.getDeclarationAccess().getGroup(), "rule__Declaration__Group__0");
			builder.put(grammarAccess.getFixedDeclarationAccess().getGroup(), "rule__FixedDeclaration__Group__0");
			builder.put(grammarAccess.getRuleAccess().getGroup_0(), "rule__Rule__Group_0__0");
			builder.put(grammarAccess.getRuleAccess().getGroup_0_7(), "rule__Rule__Group_0_7__0");
			builder.put(grammarAccess.getRuleAccess().getGroup_1(), "rule__Rule__Group_1__0");
			builder.put(grammarAccess.getCaseAccess().getGroup(), "rule__Case__Group__0");
			builder.put(grammarAccess.getOrAccess().getGroup(), "rule__Or__Group__0");
			builder.put(grammarAccess.getOrAccess().getGroup_1(), "rule__Or__Group_1__0");
			builder.put(grammarAccess.getAndAccess().getGroup(), "rule__And__Group__0");
			builder.put(grammarAccess.getAndAccess().getGroup_1(), "rule__And__Group_1__0");
			builder.put(grammarAccess.getGroupExprAccess().getGroup(), "rule__GroupExpr__Group__0");
			builder.put(grammarAccess.getAtomicAccess().getGroup_0(), "rule__Atomic__Group_0__0");
			builder.put(grammarAccess.getAtomicAccess().getGroup_0_4(), "rule__Atomic__Group_0_4__0");
			builder.put(grammarAccess.getAtomicAccess().getGroup_1(), "rule__Atomic__Group_1__0");
			builder.put(grammarAccess.getAtomicAccess().getGroup_1_4(), "rule__Atomic__Group_1_4__0");
			builder.put(grammarAccess.getAtomicAccess().getGroup_2(), "rule__Atomic__Group_2__0");
			builder.put(grammarAccess.getAtomicAccess().getGroup_2_5(), "rule__Atomic__Group_2_5__0");
			builder.put(grammarAccess.getPropertyAccess().getGroup(), "rule__Property__Group__0");
			builder.put(grammarAccess.getModelAccess().getDeclarationsAssignment_1(), "rule__Model__DeclarationsAssignment_1");
			builder.put(grammarAccess.getModelAccess().getFixedDeclarationsAssignment_2(), "rule__Model__FixedDeclarationsAssignment_2");
			builder.put(grammarAccess.getModelAccess().getRulesAssignment_4(), "rule__Model__RulesAssignment_4");
			builder.put(grammarAccess.getModelAccess().getElementsAssignment_6(), "rule__Model__ElementsAssignment_6");
			builder.put(grammarAccess.getDeclarationAccess().getNameAssignment_0(), "rule__Declaration__NameAssignment_0");
			builder.put(grammarAccess.getDeclarationAccess().getPathAssignment_2(), "rule__Declaration__PathAssignment_2");
			builder.put(grammarAccess.getFixedDeclarationAccess().getKindAssignment_0(), "rule__FixedDeclaration__KindAssignment_0");
			builder.put(grammarAccess.getFixedDeclarationAccess().getPathAssignment_2(), "rule__FixedDeclaration__PathAssignment_2");
			builder.put(grammarAccess.getRuleAccess().getNameAssignment_0_1(), "rule__Rule__NameAssignment_0_1");
			builder.put(grammarAccess.getRuleAccess().getKindAssignment_0_3(), "rule__Rule__KindAssignment_0_3");
			builder.put(grammarAccess.getRuleAccess().getDeclsAssignment_0_6(), "rule__Rule__DeclsAssignment_0_6");
			builder.put(grammarAccess.getRuleAccess().getDeclsAssignment_0_7_1(), "rule__Rule__DeclsAssignment_0_7_1");
			builder.put(grammarAccess.getRuleAccess().getCompOpAssignment_0_11(), "rule__Rule__CompOpAssignment_0_11");
			builder.put(grammarAccess.getRuleAccess().getCompValueAssignment_0_12(), "rule__Rule__CompValueAssignment_0_12");
			builder.put(grammarAccess.getRuleAccess().getNameAssignment_1_2(), "rule__Rule__NameAssignment_1_2");
			builder.put(grammarAccess.getCaseAccess().getKindAssignment_2(), "rule__Case__KindAssignment_2");
			builder.put(grammarAccess.getCaseAccess().getConditionAssignment_3(), "rule__Case__ConditionAssignment_3");
			builder.put(grammarAccess.getCaseAccess().getPropertiesAssignment_5(), "rule__Case__PropertiesAssignment_5");
			builder.put(grammarAccess.getOrAccess().getRightAssignment_1_2(), "rule__Or__RightAssignment_1_2");
			builder.put(grammarAccess.getAndAccess().getConcatKindAssignment_1_1(), "rule__And__ConcatKindAssignment_1_1");
			builder.put(grammarAccess.getAndAccess().getRightAssignment_1_2(), "rule__And__RightAssignment_1_2");
			builder.put(grammarAccess.getGroupExprAccess().getHasNotAssignment_0(), "rule__GroupExpr__HasNotAssignment_0");
			builder.put(grammarAccess.getGroupExprAccess().getExprAssignment_2(), "rule__GroupExpr__ExprAssignment_2");
			builder.put(grammarAccess.getGroupExprAccess().getCardAssignment_4(), "rule__GroupExpr__CardAssignment_4");
			builder.put(grammarAccess.getAtomicAccess().getHasNotAssignment_0_1(), "rule__Atomic__HasNotAssignment_0_1");
			builder.put(grammarAccess.getAtomicAccess().getValueAssignment_0_2(), "rule__Atomic__ValueAssignment_0_2");
			builder.put(grammarAccess.getAtomicAccess().getCardAssignment_0_3(), "rule__Atomic__CardAssignment_0_3");
			builder.put(grammarAccess.getAtomicAccess().getSentimentAssignment_0_4_1(), "rule__Atomic__SentimentAssignment_0_4_1");
			builder.put(grammarAccess.getAtomicAccess().getHasNotAssignment_1_1(), "rule__Atomic__HasNotAssignment_1_1");
			builder.put(grammarAccess.getAtomicAccess().getPosAssignment_1_2(), "rule__Atomic__PosAssignment_1_2");
			builder.put(grammarAccess.getAtomicAccess().getCardAssignment_1_3(), "rule__Atomic__CardAssignment_1_3");
			builder.put(grammarAccess.getAtomicAccess().getSentimentAssignment_1_4_1(), "rule__Atomic__SentimentAssignment_1_4_1");
			builder.put(grammarAccess.getAtomicAccess().getHasNotAssignment_2_1(), "rule__Atomic__HasNotAssignment_2_1");
			builder.put(grammarAccess.getAtomicAccess().getValueAssignment_2_3(), "rule__Atomic__ValueAssignment_2_3");
			builder.put(grammarAccess.getAtomicAccess().getCardAssignment_2_4(), "rule__Atomic__CardAssignment_2_4");
			builder.put(grammarAccess.getAtomicAccess().getSentimentAssignment_2_5_1(), "rule__Atomic__SentimentAssignment_2_5_1");
			builder.put(grammarAccess.getPropertyAccess().getFrequencyAssignment_0(), "rule__Property__FrequencyAssignment_0");
			builder.put(grammarAccess.getPropertyAccess().getCriterionAssignment_1(), "rule__Property__CriterionAssignment_1");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private MethodNameGrammarAccess grammarAccess;

	@Override
	protected InternalMethodNameParser createParser() {
		InternalMethodNameParser result = new InternalMethodNameParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public MethodNameGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(MethodNameGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
